#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct elemento{
	char *nom;
	struct elemento *next;
} el;

void inscoda(el **list, char *s){
	el *aux = *list;

	if(*list == NULL){
		(*list) = (el*)malloc(sizeof(el));
		(*list) -> nom = s;
		(*list) -> next = NULL;
	}
	else{
		while((aux -> next) != NULL)
			aux = aux -> next;
		aux -> next = (el*)malloc(sizeof(el));
		aux -> next -> nom = (char*)malloc(101*sizeof(char));
		aux -> next -> nom = s;
		aux -> next -> next = NULL;
	}
}

int compare(const void *a, const void *b){
	char* x = (char*)a;
	char* y = (char*)b;

	return strcmp(x, y);
}

el* visita(el *list){
	el *aux = list;
	
	if(list != NULL){
		free(aux -> nom);
		free(aux);
		return list->next;
	}
	return list;
}

int contael(el *list){
	int count = 0;

	while(list != NULL){
		count++;
		list = list -> next;
	}
	return count;
}

void copia(el *list, char *rim[], int dim){
	int i;

	for(i = 0; i < dim; i++){
		rim[i] = (char*)malloc(101*sizeof(char));
		rim[i] = list -> nom;
		i++;
		list = list -> next;
	}
}

int main()
{
	int e, dim;
	el *list;
	char *s, **rim;

	list = NULL;

	do{
		s = (char*)malloc(101*sizeof(char)); 
		scanf("%d", &e);
		if(e == 1){
			scanf("%s", s);
			inscoda(&list, s);
		}
		if(e == 2)
			list = visita(list);		
	}
	while(e);

	dim = contael(list);

	rim = (char**)malloc(e*sizeof(char*));

	copia(list, rim, dim);

	qsort(rim, dim, sizeof(char*), compare);

	for(e = 0; e < dim; e++)
		printf("%s\n", rim[e]);
	printf("$\n");

	return 0;
}
